Bug 1021998 - nfs mount via symbolic link does not work
nfs mount via symbolic link does not work
Status: CLOSED WONTFIX
Product: GlusterFS
Classification: Community
Component: nfs (Show other bugs)
3.4.1
x86_64 Linux
unspecified Severity unspecified
: ---
: ---
Assigned To: bugs@gluster.org
: Triaged
Depends On: 1157223
Blocks:
  Show dependency treegraph
 
Reported: 2013-10-22 09:06 EDT by albert hayr
Modified: 2015-05-26 08:33 EDT (History)
8 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 1157223 (view as bug list)
Environment:
Last Closed: 2014-12-15 03:15:55 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description albert hayr 2013-10-22 09:06:29 EDT
Description of problem:

We are using the function to export all sub-directories in a gluster volume via nfs. For real directories it works fine but if we have a symbolic link which points to the directory, it is not possible to mount that directory via nfs and the name of the link.

gluster volume on server:

drwxr-xr-x 2 root root 6 Oct 22 14:24 folder
lrwxrwxrwx 1 root root 7 Oct 22 14:24 link -> folder/


nfs mount on client:

[root@gfs01 ~]# mount -t nfs -o vers=3 172.29.1.70:/gv0/link /nfs/
mount.nfs: an incorrect mount option was specified
[root@gfs01 ~]# mount -t nfs -o vers=3 172.29.1.70:/gv0/folder /nfs/
[root@gfs01 ~]# 


Version-Release number of selected component (if applicable):


How reproducible:


Steps to Reproduce:
1. create and start a volume
2. create a directory in the volume
3. create a symbolic link to the directory in the volume 
4. try to mount from client the sub-directory via nfs an the name of the link

Actual results:

mount.nfs: an incorrect mount option was specified

Expected results:

mount to be successful 

Additional info:
Comment 1 jiademing.dd 2014-01-07 22:15:52 EST
I reproduce the issue, In my opinion, the link only point a relative path, then the NFS client can not analysis the relative path.
But in glusterfs server volume, can not create a absolute path symlink for the real sub directories.
Comment 3 Niels de Vos 2014-09-30 12:25:36 EDT
It seems that the Linux kernel NFS-server allows mounting a symlink pointing to a directory. One requirement is that the target of the symlink points to a directory that is available on the export (I have not done any detailed permission checks).
Comment 4 Niels de Vos 2014-11-17 17:10:11 EST
This has been fixed with Bug 1157223 for Gluster 3.7. We can backport this change to glusterfs-3.6, but older versions would require quite some additional work. Backports to stable branches should keep the modifications relatively small, I do not think we should backport the change(s) to 3.4 or 3.5.

Would you update to glusterfs-3.6 when we backport the change to that version?
Comment 5 Niels de Vos 2014-12-15 03:15:55 EST
Closing this bug now, there has been no response on comment #4. Please re-open this bug to request a backport.
Comment 6 Niels de Vos 2015-05-26 08:33:47 EDT
This bug has been CLOSED, and there has not been a response to the requested NEEDINFO in more than 4 weeks. The NEEDINFO flag is now getting cleared so that our Bugzilla household is getting more in order.

Note You need to log in before you can comment on or make changes to this bug.